import time
import sys
import os 
pathToThis = os.path.dirname(os.path.realpath(__file__))
referenceJsonPath = os.path.join(pathToThis, 'reference.json')

args = sys.argv[1:]
if 'ROM' in args or 'r' in args:
	if '-i' in args[1:]:
		import NotionInterface
		NotionInterface.index()
	import RomCreator
	RomCreator.main(silent='-s' in args[1:])
elif 'Index' in args or 'i' in args:
	import NotionInterface
	NotionInterface.index()
elif 'Compile' in args or 'c' in args:
	if '-i' in args[1:]:
		import NotionInterface
		NotionInterface.index()
	import Compiler
	Compiler.main(silent='-s' in args[1:], genDebugHex='-d' in args[1:], infile=args[-1] if '/' in args[-1] or '\\' in args[-1] else 'prog.asm')
elif 'Scan' in args or 's' in args:
	if '-i' in args[1:]:
		import NotionInterface
		NotionInterface.index()
	import NotionInterface
	NotionInterface.main(renumber='-rn' in args[1:])

elif 'ReNum' in args or 'rn' in args:
	import NotionInterface
	NotionInterface.main(renumber="Only")
elif 'Help' in args or 'h' in args:
	print("Loop / l / []   = Run normal loop")
	print("ROM / r         = Generate new ROM")
	print("Index / i       = Indexes notes and regenerates reference.json")
	print("Compile / c     = Compiles prog.asm to prog.hex")
	print("Scan / s        = Scans without looping")
	print("ReNum / rn      = Renumbers line IDs")
	print("Help / h        = Shows this")
	print("  -i            = Index first")
	print("  -s            = Silent")
	print("  -d            = Enable debugging features")
elif len(args) == 0 or 'Loop' in args or 'l' in args:
	import NotionInterface, RomCreator
	NotionInterface.index()
	Loop = True
	mainLoopi = 0
	while True and (Loop or mainLoopi == 0):
		NotionInterface.main(renumber=mainLoopi%20 == 19)
		if mainLoopi%10 == 9:
			NotionInterface.index()
			RomCreator.main()
		time.sleep(1)
		mainLoopi += 1
else:
	print("Couldn't find any known flags. Try Help:", args)