from convert import hexToDec, binToDec, decToBinary, hexToBinary, decToHex, binToHex
import json
import os 
pathToThis = os.path.dirname(os.path.realpath(__file__))
referenceJsonPath = os.path.join(pathToThis, 'reference.json')


with open(referenceJsonPath, 'r') as f:
	jsonData = json.loads(f.read())
	ShortHandDictionary = jsonData['SHDict']
	MCDict = jsonData['MCDict']
	InstructionsDict = jsonData['Instr2MC']


fillerHex = binToHex(MCDict["MSB"]["Mini Command"] + ShortHandDictionary['X'][2:])

def main(silent = False):
	if not silent:
		print("Building ROM from docs to 'ROM.hex' - ", end='')		
	outStr = ''
	length = 0

	for i in range(64):
		Binary = decToBinary(i, length=6, pre = False)
		if not Binary in InstructionsDict.keys():
			InstructionsDict[Binary] = ''
		# Binary : InstructionsDict[Binary]
		li = InstructionsDict[Binary].split(' ')
		for i2 in range(2**4):
			length += 1
			try:
				if li==['']:
					outStr += fillerHex + ' '
				else:
					outStr += binToHex(li[i2]) + ' '
			except:
				outStr += fillerHex + ' '
		outStr += '\n'

	with open("ROM.hex", 'w+') as f:
		f.write(outStr)
	
	if not silent:
		print("Done! Size: " + str(length) + 'b')


if __name__ == '__main__':
	main()