from convert import preToDec, hexToDec, binToDec, decToBin, hexToBin, decToHex, binToHex

class RAM():
	value = 0
	def __init__(self, value):
		self.value = value

	def Set(self, value):
		self.value = value

	def Read(self, address):
		return self.value[address]

	def Write(self, address, data):
		self.value[address] = data

class Flags():
	flags = {
			"X1": False,
			"X2": False,
			"J":  False,
			"R":  False,
			"O":  False,
			"C":  False,
			"H":  False,
			"N":  False,
		}
	def __init__(self):
		self.Reset()
	def Write(self, value):
		binaryValue = decToBin(preToDec(value), pre=False)
		self.flags = {
			"X1": bool(binaryValue[0]),
			"X2": bool(binaryValue[1]),
			"J":  bool(binaryValue[2]),
			"R":  bool(binaryValue[3]),
			"O":  bool(binaryValue[4]),
			"C":  bool(binaryValue[5]),
			"H":  bool(binaryValue[6]),
			"N":  bool(binaryValue[7]),
		}

	def Read(self):
		return binToDec("".join([str(int(x)) for x in list(self.flags.values())]))
		
	def Reset(self):
		self.flags = {
			"X1": False,
			"X2": False,
			"J":  False,
			"R":  False,
			"O":  False,
			"C":  False,
			"H":  False,
			"N":  False,
		}
	def setFlag(self, flagStr, value):
		self.flags[flagStr] = value
	def getFlag(self, flagStr):
		return self.flags[flagStr]

class counter():
	maxCnt = 0
	value = 0
	def __init__(self, maxCnt):
		self.maxCnt = maxCnt

	def Read(self):
		return self.value

	def Reset(self):
		self.value = 0

	def Inc(self):
		if self.value < self.maxCnt:
			self.value += 1
		else:
			self.value = 0

class Byte():
	value = 0
	def __init__(self, initValue=0):
		self.value = initValue

	def Write(self, data):
		while data < 0:
			data += 256
		self.value = data % 256

	def Read(self):
		return self.value

	def Reset(self):
		self.value = 0

class IncByte(Byte):
	def __init__(self, initValue=0, maxCnt=255):
		self.value = initValue
		self.maxCnt = maxCnt

	def Inc(self):
		if self.value < self.maxCnt:
			self.value += 1
		else:
			self.value = 0