def hexToDec(strHex):
	if "0x" in strHex:
		return int(strHex[2:],16)
	else:
		return int(strHex, 16)
def binToDec(strBin):
	if '0b' in strBin:
		return int(strBin[2:],2)
	else:
		return int(strBin, 2)

		
def decToBin(intDec, length = 8, pre=True):
	return ("0b" if pre else '') + f"{intDec:{'0'}{'>'}{length}{'b'}}"
def hexToBin(strHex, pre=True):
	return decToBin(hexToDec(strHex), pre=pre)


def decToHex(intDec, length = 2, pre=True):
	return ("0x" if pre else '') + f"{intDec:{'0'}{'>'}{length}{'x'}}"
def binToHex(strBin, pre=True, length=2):
	return decToHex(binToDec(strBin), pre=pre, length=length)

def preToDec(AnyNumber):
	try:
		if AnyNumber[:2] == '0x':
			return hexToDec(AnyNumber)
		if AnyNumber[:2] == '0b':
			return binToDec(AnyNumber)
		if AnyNumber[:2] == '0d':
			return AnyNumber[1:]
	except TypeError:
		return AnyNumber

if __name__ == '__main__':
	from colorama import init
	init()
	import ColoredFont as cf
	print("0x → 0d: ",
		cf.mkConditional(hexToDec("0x00")==0),
		cf.mkConditional(hexToDec("0x0f")==15),
		cf.mkConditional(hexToDec("0xf0")==240),
		cf.mkConditional(hexToDec("0xff")==255),
	)
	print("-x → 0d: ",
		cf.mkConditional(hexToDec("00")==0),
		cf.mkConditional(hexToDec("0f")==15),
		cf.mkConditional(hexToDec("f0")==240),
		cf.mkConditional(hexToDec("ff")==255),
	)
	print("0b → 0d: ",
		cf.mkConditional(binToDec("0b00000000")==0),
		cf.mkConditional(binToDec("0b00001111")==15),
		cf.mkConditional(binToDec("0b11110000")==240),
		cf.mkConditional(binToDec("0b11111111")==255),
	)
	print("-b → 0d: ",
		cf.mkConditional(binToDec("00000000")==0),
		cf.mkConditional(binToDec("00001111")==15),
		cf.mkConditional(binToDec("11110000")==240),
		cf.mkConditional(binToDec("11111111")==255),
	)
	print("-d → 0b: ",
		cf.mkConditional(decToBin(0, pre=True, length=4) == "0b0000"),
		cf.mkConditional(decToBin(15, pre=True, length=8) == "0b00001111"),
		cf.mkConditional(decToBin(12, pre=False, length=4) == "1100"),
		cf.mkConditional(decToBin(255, pre=False, length=8) == "11111111"),
	)
	print("0x → 0b: ",
		cf.mkConditional(hexToBin("0x00") == "0b00000000"),
		cf.mkConditional(hexToBin("0x0f") == "0b00001111"),
		cf.mkConditional(hexToBin("0xf0") == "0b11110000"),
		cf.mkConditional(hexToBin("0xff") == "0b11111111"),
	)
	print("-x → 0b: ",
		cf.mkConditional(hexToBin("00") == "0b00000000"),
		cf.mkConditional(hexToBin("0f") == "0b00001111"),
		cf.mkConditional(hexToBin("f0") == "0b11110000"),
		cf.mkConditional(hexToBin("ff") == "0b11111111"),
	)
	print("-d → 0x: ",
		cf.mkConditional(decToHex(0, pre=True) == "0x00"),
		cf.mkConditional(decToHex(15, pre=True) == "0x0f"),
		cf.mkConditional(decToHex(240, pre=False) == "f0"),
		cf.mkConditional(decToHex(255, pre=False) == "ff"),
	)
	print("0b → 0x: ",
		cf.mkConditional(binToHex("0b00000000") == "0x00"),
		cf.mkConditional(binToHex("0b00001111") == "0x0f"),
		cf.mkConditional(binToHex("0b11110000") == "0xf0"),
		cf.mkConditional(binToHex("0b11111111") == "0xff"),
	)

	print("?? → 0d: ",
		cf.mkConditional(preToDec("0x01") == 1),
		cf.mkConditional(preToDec("0x55") == 85),
		cf.mkConditional(preToDec("0b01101001") == 105),
		cf.mkConditional(preToDec("0b01100110") == 102),
	)

	
